/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 *   	imgread -
 *		Read an image into arrays of chars or shorts.
 *	see fastimg.c for code to read images into arrays of longs.
 *
 *				Paul Haeberli - 1988
 */
#include "stdio.h"
#include "image.h"

short *shortimagedata(name)
char *name;
{
    short *base, *sptr;
    IMAGE *image;
    int y;

    if( (image=iopen(name,"r")) == NULL ) {
	fprintf(stderr,"shortimagedata: can't open input file %s\n",name);
	exit(1);
    }
    base = (short *)mymalloc(sizeof(short)*image->xsize*image->ysize);
    sptr = base;
    for(y=0; y<image->ysize; y++) {
	getbwrow(image,sptr,y);
	sptr += image->xsize;
    }
    iclose(image);
    return base;
}

char *charimagedata(name)
char *name;
{
    char *base, *cptr;
    short *rbuf, *gbuf, *bbuf;
    IMAGE *image;
    int y;

    image = iopen(name,"r");
    if(!image) {
	fprintf(stderr,"charimagedata: can't open image file %s\n",name);
	exit(1);
    }
    base = (char *)mymalloc(image->xsize*image->ysize*sizeof(char));
    rbuf = (short *)mymalloc(image->xsize*sizeof(short));
    if(!base || !rbuf) {
	fprintf(stderr,"charimagedata: can't malloc enough memory\n");
	exit(1);
    }
    cptr = base;
    for(y=0; y<image->ysize; y++) {
	getrow(image,rbuf,y,0);
	stoc(rbuf,cptr,image->xsize);
	cptr += image->xsize;
    }
    iclose(image);
    free(rbuf);
    return base;
}
